import { FC } from 'react';
import { ReaderManagerArguments, UseWebReaderArguments } from './types';
/**
 * The main React component export.
 */
export declare type WebReaderProps = UseWebReaderArguments & ReaderManagerArguments;
export declare const WebReaderWithoutBoundary: FC<WebReaderProps>;
declare const WebReader: FC<WebReaderProps>;
export default WebReader;
export { usePublicationSW } from './ServiceWorker/index';
export { default as useWebReader } from './useWebReader';
export { default as useHtmlReader } from './HtmlReader';
export { default as usePdfReader } from './PdfReader';
export { getTheme } from './ui/theme';
export { default as useColorModeValue } from './ui/hooks/useColorModeValue';
export * from './constants';
