import { Dict } from '../types';
declare const ButtonStyle: {
    baseStyle: {
        borderRadius: string;
        fontWeight: string;
    };
    sizes: {
        lg: {
            h: number;
            minW: number;
            fontSize: string;
            px: number;
        };
        md: {
            h: string;
            minW: number;
            fontSize: string;
            px: number;
        };
        sm: {
            h: number;
            minW: number;
            fontSize: string;
            px: number;
        };
        xs: {
            h: number;
            minW: number;
            fontSize: string;
            px: number;
        };
    };
    variants: {
        pill: {
            border: string;
            borderColor: string;
            borderRadius: string;
            height: number;
            px: number;
            fontSize: string;
            my: string;
        };
        solid: typeof variantSolid;
        secondary: {
            border: string;
            borderColor: string;
            _hover: {
                bg: string;
                borderColor: string;
            };
        };
    };
    defaultProps: {
        size: string;
        variant: string;
        colorScheme: string;
    };
};
declare function variantSolid(props: Dict): {
    _hover: {
        _disabled: {
            bg: string;
            color: string;
        };
    };
    _disabled: {
        bg: string;
        color: string;
    };
    bg: string;
    _active: {
        bg: string;
    };
    color?: undefined;
    hoverBg?: undefined;
    activeBg?: undefined;
} | {
    _hover: {
        _disabled: {
            bg: string;
            color: string;
        };
    };
    _disabled: {
        bg: string;
        color: string;
    };
    bg: string;
    color: string;
    hoverBg: string;
    activeBg: string;
    _active?: undefined;
};
export default ButtonStyle;
