/**
 * A comprehensive spacin scale based on NYPL Design System,
 * with intermediate values interpolated. Those marked with comments
 * are directly from the NYPL DS.
 *
 * 1 spacing unit is 4px or 0.25rem.
 *
 * Mental model: If you need a spacing of 40px, divide it by 4.
 * That'll give you 10. Then use it in your component.
 */
declare const spacing: {
    space: {
        px: string;
        0: string;
        0.5: string;
        1: string;
        1.5: string;
        2: string;
        2.5: string;
        3: string;
        3.5: string;
        4: string;
        5: string;
        6: string;
        7: string;
        8: string;
        9: string;
        10: string;
        12: string;
        14: string;
        16: string;
        20: string;
        24: string;
        28: string;
        32: string;
        36: string;
        40: string;
        44: string;
        48: string;
        52: string;
        56: string;
        60: string;
        64: string;
        72: string;
        80: string;
        96: string;
    };
};
export default spacing;
