import { Button } from '@chakra-ui/react';
import React from 'react';
import { GetColor } from '../../../types';
declare const getButtonStyle: (getColor: GetColor) => {
    readonly baseStyle: {
        readonly borderRadius: "none";
    };
    readonly sizes: {};
    readonly variants: {
        readonly solid: (props: React.ComponentProps<typeof Button>) => {
            border: string;
            borderColor: string;
            transition: string;
            fontSize: number;
            letterSpacing: number;
            textTransform: string;
            maxWidth: string;
            cursor: string;
            bgColor: string;
            color: string;
            _focus: {
                bgColor: string;
                color: string;
            };
            _hover: {
                bgColor: string;
                color: string;
                _disabled: {
                    bgColor: string;
                };
            };
            _active: {
                bgColor: string;
                color: string;
            };
            _checked: {
                bgColor: string;
                color: string;
            };
            _disabled: {
                bgColor: string;
            };
        };
        readonly toggle: (props: React.ComponentProps<typeof Button>) => {
            bgColor: string;
            color: string;
            px: number;
            fontWeight: string;
            fontSize: number;
            _focus: {
                bgColor: string;
            };
            _hover: {
                bgColor: string;
            };
            _active: {
                bgColor: string;
            };
            _checked: {
                color: string;
                bgColor: string;
            };
            border: string;
            borderColor: string;
            transition: string;
            letterSpacing: number;
            textTransform: string;
            maxWidth: string;
            cursor: string;
            _disabled: {
                bgColor: string;
            };
        };
    };
    readonly defaultProps: {
        readonly size: "sm";
        readonly variant: "solid";
    };
};
export default getButtonStyle;
